#include "stc.h"
#include "interface.h"
#include "uart.h"

//P1.0(TK00)   P1.1(TK01)   P5.4(TK02)   P1.3(TK03)   P1.4(TK04)   P1.5(TK05)   P1.6(TK06)   P1.7(TK07)
//P5.0(TK08)   P5.1(TK09)   P5.2(TK10)   P5.3(TK11)   P0.0(TK12)   P0.1(TK13)   P0.2(TK14)   P0.3(TK15)

#define		TS_Channel		16						//ͨ
#define		TS_Compare		0x0800					//Ƚֵ
#define		TS_Range		0x0400					//ֵ

unsigned char code	TS_Map[16]={0xFF,0xFF,0x06,0xFF,0xFF,0xFF,0xFF,0xFF,0x05,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};	//ͨӳ
unsigned int xdata	TS_Buf[5][TS_Channel];	//ݣʵֵԤֵСֵֵ
unsigned char		TS_Select;				//ѡͨ鿴TS_Buf4λΪάȣΧ0x*0-0x*B4λΪάȣΧ0x0*-0x4*
unsigned char		TS_Scan;				//ɨͨ
bit					TS_Flag;				//жϱ־
unsigned char		TS_Calibrate;			//У׼״̬
unsigned char		TS_Pad;					//ť״̬
unsigned char		TS_Ring;				//״̬
unsigned char		TS_Slide;				//״̬
unsigned int		Ring;					//ֵ
unsigned int		Slide;					//ֵ


void Delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=FOSC/10000;
		while(--i);	//10T per loop
	}
	while(--ms);
}

unsigned int Compare(bit x,unsigned int a,unsigned int b)
{
	return a==b?a:(x==0?(a<b?a:b):(a>b?a:b));
}

void Calibrate(void)
{
	unsigned char i;
	static unsigned char flag;
	switch(TS_Calibrate)
	{
		case 0:
			flag=0x0F;
		break;
		case 1:
			if(flag&0x01)
			{
				flag&=0x0E;
				TS_Buf[2][TS_Select&0x0F]=TS_Buf[1][TS_Select&0x0F];
			}
			else
			{
				TS_Buf[2][TS_Select&0x0F]=Compare(0,TS_Buf[1][TS_Select&0x0F],TS_Buf[2][TS_Select&0x0F]);
			}
		break;
		case 2:
			if(flag&0x02)
			{
				flag&=0x0D;
				TS_Buf[3][TS_Select&0x0F]=TS_Buf[1][TS_Select&0x0F];
			}
			else
			{
				TS_Buf[3][TS_Select&0x0F]=Compare(1,TS_Buf[1][TS_Select&0x0F],TS_Buf[3][TS_Select&0x0F]);
			}
		break;
		case 3:
			if(flag&0x04)
			{
				flag&=0x0B;
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[2][i]=TS_Buf[1][i];
				}
			}
			else
			{
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[2][i]=Compare(0,TS_Buf[1][i],TS_Buf[2][i]);
				}
			}
		break;
		case 4:
			if(flag&0x08)
			{
				flag&=0x07;
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[3][i]=TS_Buf[1][i];
				}
			}
			else
			{
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[3][i]=Compare(1,TS_Buf[1][i],TS_Buf[3][i]);
				}
			}
		break;
		default:
			
		break;
	}
}

void Touch_Pad(void)
{
	unsigned char i;
	unsigned int limit_l,limit_h;
	limit_l=TS_Compare-TS_Range/2;
	limit_h=TS_Compare+TS_Range/2;
	for(i=0;i<5;i++)
	{
		if(TS_Buf[4][i]<=limit_l)
		{
			TS_Pad&=~(0x01<<i);
		}
		if(TS_Buf[4][i]>=limit_h)
		{
			TS_Pad|=0x01<<i;
		}
	}
}

void Touch_Ring(void)
{
	unsigned char i;
	unsigned int limit_l,limit_h;
	limit_l=TS_Compare-TS_Range/2;
	limit_h=TS_Compare+TS_Range/2;

    TS_Ring = 0;
	for(i=0;i<3;i++)
	{
		if(TS_Buf[4][i+5]<=limit_l)
		{
			TS_Ring&=~(0x01<<i);
		}
		if(TS_Buf[4][i+5]>=limit_h)
		{
			TS_Ring|=0x01<<i;
		}
	}
	if(TS_Ring&0x07)
	{
		TS_Ring|=0x80;
		if(TS_Ring==0x81|TS_Ring==0x82|TS_Ring==0x83|TS_Ring==0x84|TS_Ring==0x85|TS_Ring==0x86)
		{
			if(TS_Buf[4][0x05]>=TS_Buf[4][0x06]&&TS_Buf[4][0x05]>=TS_Buf[4][0x07])
			{
				if(TS_Buf[4][0x06]>=TS_Buf[4][0x07])
				{
					Ring=((TS_Buf[4][0x06]-(TS_Buf[4][0x07]*(TS_Buf[4][0x05]/(TS_Buf[4][0x06]*2))))*0x0555UL)/(TS_Buf[4][0x05]+TS_Buf[4][0x06]);
				}
				else
				{
					Ring=((TS_Buf[4][0x05]+(TS_Buf[4][0x06]*(TS_Buf[4][0x05]/(TS_Buf[4][0x07]*2))))*0x0555UL)/(TS_Buf[4][0x07]+TS_Buf[4][0x05])+0x0AAA;
				}
			}
			else if(TS_Buf[4][0x06]>=TS_Buf[4][0x05]&&TS_Buf[4][0x06]>=TS_Buf[4][0x07])
			{
				if(TS_Buf[4][0x07]>=TS_Buf[4][0x05])
				{
					Ring=((TS_Buf[4][0x07]-(TS_Buf[4][0x05]*(TS_Buf[4][0x06]/(TS_Buf[4][0x07]*2))))*0x0555UL)/(TS_Buf[4][0x06]+TS_Buf[4][0x07])+0x0555;
				}
				else
				{
					Ring=((TS_Buf[4][0x06]+(TS_Buf[4][0x07]*(TS_Buf[4][0x06]/(TS_Buf[4][0x05]*2))))*0x0555UL)/(TS_Buf[4][0x05]+TS_Buf[4][0x06]);
				}
			}
			else if(TS_Buf[4][0x07]>=TS_Buf[4][0x05]&&TS_Buf[4][0x07]>=TS_Buf[4][0x06])
			{
				if(TS_Buf[4][0x05]>=TS_Buf[4][0x06])
				{
					Ring=((TS_Buf[4][0x05]-(TS_Buf[4][0x06]*(TS_Buf[4][0x07]/(TS_Buf[4][0x05]*2))))*0x0555UL)/(TS_Buf[4][0x07]+TS_Buf[4][0x05])+0x0AAA;
				}
				else
				{
					Ring=((TS_Buf[4][0x07]+(TS_Buf[4][0x05]*(TS_Buf[4][0x07]/(TS_Buf[4][0x06]*2))))*0x0555UL)/(TS_Buf[4][0x06]+TS_Buf[4][0x07])+0x0555;
				}
			}
		}
		else
		{
			Ring=0;
		}
	}
	else
	{
		TS_Ring&=0x7F;
		Ring=0;
	}
}

void Touch_Slide(void)
{
	
}

void Touch_Key(void)
{
	unsigned char i;
	if(TS_Flag)
	{
		TS_Flag=0;
		for(i=0;i<TS_Channel;i++)
		{
			TS_Buf[1][i]=TS_Buf[1][i]*3+((0xFFFF-TS_Buf[0][i])>>2)>>2;
			if(TS_Buf[3][i]>TS_Buf[2][i])
			{
				TS_Buf[4][i]=(TS_Buf[1][i]>TS_Buf[2][i]?(TS_Buf[1][i]-TS_Buf[2][i]):0)*0x1000UL/(TS_Buf[3][i]-TS_Buf[2][i]);
				if(TS_Buf[4][i]>0x0FFF)
				{
					TS_Buf[4][i]=0x0FFF;
				}
			}
			else
			{
				TS_Buf[4][i]=0;
			}
		}
		Calibrate();
		Touch_Pad();
		Touch_Ring();
		Touch_Slide();
	}
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P0=0x00;
	P1=0x03;
	P2=0x00;
	P3=0x03;
	P4=0x00;
	P5=0x00;
	P6=0xA8;
	P7=0x00;
	
	P0M0=0x00;
	P0M1=0xFF; 
	P1M0=0x02;
	P1M1=0xFC; 
	P2M0=0x00;
	P2M1=0xFF; 
	P3M0=0x02;
	P3M1=0xFC; 
	P4M0=0x00;
	P4M1=0xFF; 
	P5M0=0x00;
	P5M1=0xFF; 
	P6M0=0xE8;
	P6M1=0x07; 
	P7M0=0x00;
	P7M1=0xFF; 
    
    uart_init();
	
	TSCHEN1=0x04;	//TK00~TK07
	TSCHEN2=0x03;	//TK08~TK15
	TSRT=0x00;		//ûLEDʱɨ
	TSCFG1=0x73;	//صݹƵ = fosc/(2*(TSCFG1[6:4]+1))ŵʱ(ϵͳʱ) 0(125) 1(250) 2(500) 3(1000) 4(2000) 5(2500) 6(5000) 7(7500) С3
	TSCFG2=0x03;	//ôڲοѹ(AVCCķѹ)0(1/4)  1(1/2)  2(5/8)  3(3/4)
	TSCTRL=0x33;	//ظɨģʽһɨͣ͹ģʽʱΪⲿ32768񣬹رֱȽرյ͹Ļѣ4ƽB7: TSGOB6: SINGLEB5: TSWAITB4: TSWUCSB3: TSDCENB2: TSWUENB1 B0: TSSAMP
	TSCTRL|=0x80;	//ʼɨ
	IE2|=0x80;		//ôж
	
	EA=1;			//ж

	memset(TS_Buf,0x00,sizeof TS_Buf);
	
	TS_Buf[2][0x05]=13966;  //TS_Buf[1]Сֵ
	TS_Buf[2][0x06]=14026;
	TS_Buf[2][0x07]=14024;

	TS_Buf[3][0x05]=15352;  //TS_Buf[1]ֵ
	TS_Buf[3][0x06]=15453;
	TS_Buf[3][0x07]=15427;
	
	TS_Select=0x44;
}

void main(void)
{
	Init();
	while(1)
	{
		Touch_Key();
        SEG7_ShowLong(Ring, 10);
		Delay_ms(100);
	}
}

void TKSU_Isr(void) interrupt TKSU_VECTOR
{
	unsigned char temp;
	temp=TSSTA2;
	if(temp&0x40)		//, 
	{
		TSSTA2|=0x40;	//д1
	}
	else if(temp&0x80)	//ɨ
	{
		TS_Scan=temp&0x0f;
		if(TS_Map[TS_Scan]!=0xFF)	//ͨȷ
		{
			TS_Buf[0][TS_Map[TS_Scan]]=TSDAT;	//ĳͨĶ
			TS_Flag=1;
		}
	}
	TSSTA2|=0x80;		//д1
}